SystemOrganization addCategory: #'PocketCube-Tests'!
SystemOrganization addCategory: #'PocketCube-Morph'!
SystemOrganization addCategory: #PocketCube!
SystemOrganization addCategory: #'PocketCube-Recognizer'!

TestCase subclass: #PocketCubeSideTest
	instanceVariableNames: 'side'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Tests'!

!PocketCubeSideTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/17/2010 19:45'!
setUp

	super setUp.
	side := PocketCubeSide upperLeftPiece: 1 upperRightPiece: 2 lowerLeftPiece: 3 lowerRightPiece: 4! !

!PocketCubeSideTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/17/2010 20:03'!
testCopyInLowerLayer

	side copyInLowerLayer: (Array with: 5 with: 6).
	self assert: side copyOutUpperLayer = (Array with:1 with:2).
	self assert: side copyOutLowerLayer = (Array with:5 with:6)! !

!PocketCubeSideTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/17/2010 20:01'!
testCopyInUpperLayer

	side copyInUpperLayer: (Array with: 5 with: 6).
	self assert: side copyOutUpperLayer = (Array with:5 with:6).
	self assert: side copyOutLowerLayer = (Array with:3 with:4)! !

!PocketCubeSideTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/17/2010 19:54'!
testCopyOutLowerLayer

	|twoPieces| 
	twoPieces := side copyOutLowerLayer.
	self assert: twoPieces = (Array with:3 with:4)! !

!PocketCubeSideTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/17/2010 19:53'!
testCopyOutUpperLayer

	|twoPieces| 
	twoPieces := side copyOutUpperLayer.
	self assert: twoPieces = (Array with:1 with:2)! !

!PocketCubeSideTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 01:31'!
testEqual

	self assert: side = (PocketCubeSide upperLeftPiece: 1 upperRightPiece: 2 lowerLeftPiece: 3 lowerRightPiece: 4).
	self deny: side = (PocketCubeSide upperLeftPiece: 1 upperRightPiece: 6 lowerLeftPiece: 3 lowerRightPiece: 4).
	self deny: side = (PocketCubeSide upperLeftPiece: 0 upperRightPiece: 2 lowerLeftPiece: 3 lowerRightPiece: 4).
	self deny: side = (PocketCubeSide upperLeftPiece: 1 upperRightPiece: 2 lowerLeftPiece: 9 lowerRightPiece: 4).
	self deny: side = (PocketCubeSide upperLeftPiece: 1 upperRightPiece: 2 lowerLeftPiece: 3 lowerRightPiece: 7).
! !

!PocketCubeSideTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 01:32'!
testHash

	self assert: side hash = (PocketCubeSide upperLeftPiece: 1 upperRightPiece: 2 lowerLeftPiece: 3 lowerRightPiece: 4) hash.
	self deny: side hash = (PocketCubeSide upperLeftPiece: 1 upperRightPiece: 6 lowerLeftPiece: 3 lowerRightPiece: 4) hash.
	self deny: side hash = (PocketCubeSide upperLeftPiece: 0 upperRightPiece: 2 lowerLeftPiece: 3 lowerRightPiece: 4) hash.
	self deny: side hash = (PocketCubeSide upperLeftPiece: 1 upperRightPiece: 2 lowerLeftPiece: 9 lowerRightPiece: 4) hash.
	self deny: side hash = (PocketCubeSide upperLeftPiece: 1 upperRightPiece: 2 lowerLeftPiece: 3 lowerRightPiece: 7) hash.
! !

!PocketCubeSideTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:54'!
testPrintPieces

	self assert: side printPieces = 
'1 2
3 4'! !

!PocketCubeSideTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/17/2010 19:35'!
testRotateClockwise

	side rotateClockwise.
	self assert: side upperLeftPiece = 3.
	self assert: side upperRightPiece = 1.
	self assert: side lowerLeftPiece = 4.
	self assert: side lowerRightPiece = 2! !

!PocketCubeSideTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/17/2010 19:46'!
testRotateCounterClockwise

	side rotateCounterClockwise.
	self assert: side upperLeftPiece = 2.
	self assert: side upperRightPiece = 4.
	self assert: side lowerLeftPiece = 1.
	self assert: side lowerRightPiece = 3! !

!PocketCubeSideTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/17/2010 19:37'!
testSetup

	self assert: side upperLeftPiece = 1.
	self assert: side upperRightPiece = 2.
	self assert: side lowerLeftPiece = 3.
	self assert: side lowerRightPiece = 4! !

TestCase subclass: #PocketCubeSolverTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Tests'!

TestCase subclass: #PocketCubeTest
	instanceVariableNames: 'pocketCube'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Tests'!

PocketCubeTest subclass: #PocketCubeRotateClockwiseTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Tests'!

!PocketCubeRotateClockwiseTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 09:52'!
setUp

	super setUp.
	pocketCube rotateClockwise.! !

!PocketCubeRotateClockwiseTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 09:53'!
testBackSide

	self assert: pocketCube backSide = (PocketCubeSide upperLeftPiece:12 upperRightPiece: 20 lowerLeftPiece: 11 lowerRightPiece: 19)! !

!PocketCubeRotateClockwiseTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 09:55'!
testBottomSide

	self assert: pocketCube bottomSide = (PocketCubeSide upperLeftPiece: 17 upperRightPiece: 9 lowerLeftPiece: 18 lowerRightPiece: 10)! !

!PocketCubeRotateClockwiseTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 09:54'!
testFrontSide

	self assert: pocketCube frontSide = (PocketCubeSide upperLeftPiece:15 upperRightPiece: 7 lowerLeftPiece: 16 lowerRightPiece: 8)! !

!PocketCubeRotateClockwiseTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 09:55'!
testLeftSide

	self assert: pocketCube leftSide = (PocketCubeSide upperLeftPiece: 23 upperRightPiece: 21 lowerLeftPiece: 24 lowerRightPiece: 22)! !

!PocketCubeRotateClockwiseTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 09:56'!
testRightSide

	self assert: pocketCube rightSide = (PocketCubeSide upperLeftPiece: 3 upperRightPiece: 1 lowerLeftPiece: 4 lowerRightPiece: 2)! !

!PocketCubeRotateClockwiseTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 09:56'!
testTopSide

	self assert: pocketCube topSide = (PocketCubeSide upperLeftPiece: 13 upperRightPiece: 5 lowerLeftPiece: 14 lowerRightPiece: 6)! !

PocketCubeTest subclass: #PocketCubeRotateCounterClockwiseTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Tests'!

!PocketCubeRotateCounterClockwiseTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 22:13'!
setUp

	super setUp.
	pocketCube rotateCounterClockwise.! !

!PocketCubeRotateCounterClockwiseTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 22:15'!
testBackSide

	self assert: pocketCube backSide = (PocketCubeSide upperLeftPiece:19 upperRightPiece: 11 lowerLeftPiece: 20 lowerRightPiece: 12)! !

!PocketCubeRotateCounterClockwiseTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 22:16'!
testBottomSide

	self assert: pocketCube bottomSide = (PocketCubeSide upperLeftPiece: 6 upperRightPiece: 14 lowerLeftPiece: 5 lowerRightPiece: 13)! !

!PocketCubeRotateCounterClockwiseTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 22:16'!
testFrontSide

	self assert: pocketCube frontSide = (PocketCubeSide upperLeftPiece:8 upperRightPiece: 16 lowerLeftPiece: 7 lowerRightPiece: 15)! !

!PocketCubeRotateCounterClockwiseTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 22:17'!
testLeftSide

	self assert: pocketCube leftSide = (PocketCubeSide upperLeftPiece: 2 upperRightPiece: 4 lowerLeftPiece: 1 lowerRightPiece: 3)! !

!PocketCubeRotateCounterClockwiseTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 22:17'!
testRightSide

	self assert: pocketCube rightSide = (PocketCubeSide upperLeftPiece: 22 upperRightPiece: 24 lowerLeftPiece: 21 lowerRightPiece: 23)! !

!PocketCubeRotateCounterClockwiseTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 22:18'!
testTopSide

	self assert: pocketCube topSide = (PocketCubeSide upperLeftPiece: 10 upperRightPiece: 18 lowerLeftPiece: 9 lowerRightPiece: 17)! !

PocketCubeTest subclass: #PocketCubeRotateLeftTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Tests'!

!PocketCubeRotateLeftTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 01:35'!
setUp

	super setUp.
	pocketCube rotateLeft.! !

!PocketCubeRotateLeftTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:43'!
testBackSide

	self assert: pocketCube backSide = (PocketCubeSide upperLeftPiece:9 upperRightPiece: 10 lowerLeftPiece: 17 lowerRightPiece: 18)! !

!PocketCubeRotateLeftTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 09:23'!
testBottomSide

	self assert: pocketCube bottomSide = (PocketCubeSide upperLeftPiece: 23 upperRightPiece: 21 lowerLeftPiece: 24 lowerRightPiece: 22)! !

!PocketCubeRotateLeftTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 09:38'!
testFrontSide

	self assert: pocketCube frontSide = (PocketCubeSide upperLeftPiece:5 upperRightPiece: 6 lowerLeftPiece: 13 lowerRightPiece: 14)! !

!PocketCubeRotateLeftTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 09:30'!
testLeftSide

	self assert: pocketCube leftSide = (PocketCubeSide upperLeftPiece: 11 upperRightPiece: 12 lowerLeftPiece: 19 lowerRightPiece: 20)! !

!PocketCubeRotateLeftTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 09:33'!
testRightSide

	self assert: pocketCube rightSide = (PocketCubeSide upperLeftPiece: 7 upperRightPiece: 8 lowerLeftPiece: 15 lowerRightPiece: 16)! !

!PocketCubeRotateLeftTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:40'!
testTopSide

	self assert: pocketCube topSide = (PocketCubeSide upperLeftPiece: 2 upperRightPiece: 4 lowerLeftPiece: 1 lowerRightPiece: 3)! !

PocketCubeTest subclass: #PocketCubeRotateRightTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Tests'!

!PocketCubeRotateRightTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 09:29'!
setUp

	super setUp.
	pocketCube rotateRight.! !

!PocketCubeRotateRightTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 09:34'!
testBackSide

	self assert: pocketCube backSide = (PocketCubeSide upperLeftPiece:5 upperRightPiece: 6 lowerLeftPiece: 13 lowerRightPiece: 14)! !

!PocketCubeRotateRightTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 09:34'!
testBottomSide

	self assert: pocketCube bottomSide = (PocketCubeSide upperLeftPiece: 22 upperRightPiece: 24 lowerLeftPiece: 21 lowerRightPiece: 23)! !

!PocketCubeRotateRightTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 09:37'!
testFrontSide

	self assert: pocketCube frontSide = (PocketCubeSide upperLeftPiece:9 upperRightPiece: 10 lowerLeftPiece: 17 lowerRightPiece: 18)! !

!PocketCubeRotateRightTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 09:39'!
testLeftSide

	self assert: pocketCube leftSide = (PocketCubeSide upperLeftPiece: 7 upperRightPiece: 8 lowerLeftPiece: 15 lowerRightPiece: 16)! !

!PocketCubeRotateRightTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 09:39'!
testRightSide

	self assert: pocketCube rightSide = (PocketCubeSide upperLeftPiece: 11 upperRightPiece: 12 lowerLeftPiece: 19 lowerRightPiece: 20)! !

!PocketCubeRotateRightTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 09:37'!
testTopSide

	self assert: pocketCube topSide = (PocketCubeSide upperLeftPiece: 3 upperRightPiece: 1 lowerLeftPiece: 4 lowerRightPiece: 2)! !

!PocketCubeTest methodsFor: 'running' stamp: 'hjo 7/17/2010 20:32'!
setUp

	super setUp.
	pocketCube := PocketCube new.
	pocketCube topSide: (PocketCubeSide upperLeftPiece: 1 upperRightPiece: 2 lowerLeftPiece: 3 lowerRightPiece: 4).
	pocketCube leftSide: (PocketCubeSide upperLeftPiece: 5 upperRightPiece: 6 lowerLeftPiece: 13 lowerRightPiece: 14).
	pocketCube bottomSide: (PocketCubeSide upperLeftPiece: 21 upperRightPiece: 22 lowerLeftPiece: 23 lowerRightPiece: 24).
	pocketCube rightSide: (PocketCubeSide upperLeftPiece: 9 upperRightPiece: 10 lowerLeftPiece: 17 lowerRightPiece: 18).
	pocketCube frontSide: (PocketCubeSide upperLeftPiece: 7 upperRightPiece: 8 lowerLeftPiece: 15 lowerRightPiece: 16).
	pocketCube backSide: (PocketCubeSide upperLeftPiece: 11 upperRightPiece: 12 lowerLeftPiece: 19 lowerRightPiece: 20).! !

!PocketCubeTest methodsFor: 'setup testing' stamp: 'hjo 7/18/2010 07:36'!
testBackSide

	self assert: pocketCube backSide = (PocketCubeSide upperLeftPiece:11 upperRightPiece: 12 lowerLeftPiece: 19 lowerRightPiece: 20)! !

!PocketCubeTest methodsFor: 'setup testing' stamp: 'hjo 7/18/2010 07:36'!
testBottomSide

	self assert: pocketCube bottomSide = (PocketCubeSide upperLeftPiece: 21 upperRightPiece: 22 lowerLeftPiece: 23 lowerRightPiece: 24)! !

!PocketCubeTest methodsFor: 'setup testing' stamp: 'hjo 7/18/2010 07:36'!
testFrontSide

	self assert: pocketCube frontSide = (PocketCubeSide upperLeftPiece: 7 upperRightPiece: 8 lowerLeftPiece: 15 lowerRightPiece: 16)! !

!PocketCubeTest methodsFor: 'setup testing' stamp: 'hjo 7/18/2010 07:37'!
testLeftSide

	self assert: pocketCube leftSide = (PocketCubeSide upperLeftPiece: 5 upperRightPiece: 6 lowerLeftPiece: 13 lowerRightPiece: 14)! !

!PocketCubeTest methodsFor: 'setup testing' stamp: 'hjo 7/18/2010 07:37'!
testRightSide

	self assert: pocketCube rightSide = (PocketCubeSide upperLeftPiece: 9 upperRightPiece: 10 lowerLeftPiece: 17 lowerRightPiece: 18)! !

!PocketCubeTest methodsFor: 'setup testing' stamp: 'hjo 7/18/2010 07:37'!
testTopSide

	self assert: pocketCube topSide = (PocketCubeSide upperLeftPiece: 1 upperRightPiece: 2 lowerLeftPiece: 3 lowerRightPiece: 4)! !

PocketCubeTest subclass: #PocketCubeWhenTwistLowerLayerLeft
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Tests'!

!PocketCubeWhenTwistLowerLayerLeft methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:15'!
setUp

	super setUp.
	pocketCube twistLowerLayerLeft.! !

!PocketCubeWhenTwistLowerLayerLeft methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:19'!
testBackSide

	self assert: pocketCube backSide = (PocketCubeSide upperLeftPiece: 11 upperRightPiece: 12 lowerLeftPiece: 13 lowerRightPiece: 14).! !

!PocketCubeWhenTwistLowerLayerLeft methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:20'!
testBottomSide

	self assert: pocketCube bottomSide = (PocketCubeSide upperLeftPiece: 22 upperRightPiece: 24 lowerLeftPiece: 21 lowerRightPiece: 23)! !

!PocketCubeWhenTwistLowerLayerLeft methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:18'!
testFrontSide

	self assert: pocketCube frontSide = (PocketCubeSide upperLeftPiece: 7 upperRightPiece: 8 lowerLeftPiece: 17 lowerRightPiece: 18).! !

!PocketCubeWhenTwistLowerLayerLeft methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:18'!
testLeftSide

	self assert: pocketCube leftSide = (PocketCubeSide upperLeftPiece: 5 upperRightPiece: 6  lowerLeftPiece: 15 lowerRightPiece: 16)! !

!PocketCubeWhenTwistLowerLayerLeft methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:19'!
testRightSide

	self assert: pocketCube rightSide = (PocketCubeSide upperLeftPiece: 9 upperRightPiece: 10 lowerLeftPiece: 19 lowerRightPiece: 20)! !

!PocketCubeWhenTwistLowerLayerLeft methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:20'!
testTopSide

	self assert: pocketCube topSide = (PocketCubeSide upperLeftPiece: 1 upperRightPiece: 2  lowerLeftPiece: 3 lowerRightPiece: 4)! !

PocketCubeTest subclass: #PocketCubeWhenTwistLowerLayerRight
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Tests'!

!PocketCubeWhenTwistLowerLayerRight methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:22'!
setUp

	super setUp.
	pocketCube twistLowerLayerRight! !

!PocketCubeWhenTwistLowerLayerRight methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:25'!
testBackSide

	self assert: pocketCube backSide = (PocketCubeSide upperLeftPiece: 11 upperRightPiece: 12 lowerLeftPiece: 17 lowerRightPiece: 18)! !

!PocketCubeWhenTwistLowerLayerRight methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:23'!
testBottomSide

	self assert: pocketCube bottomSide = (PocketCubeSide upperLeftPiece: 23 upperRightPiece: 21 lowerLeftPiece: 24 lowerRightPiece: 22).! !

!PocketCubeWhenTwistLowerLayerRight methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:24'!
testFrontSide

	self assert: pocketCube frontSide = (PocketCubeSide upperLeftPiece: 7 upperRightPiece: 8 lowerLeftPiece: 13 lowerRightPiece: 14)! !

!PocketCubeWhenTwistLowerLayerRight methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:23'!
testLeftSide

	self assert: pocketCube leftSide = (PocketCubeSide upperLeftPiece: 5 upperRightPiece: 6  lowerLeftPiece: 19 lowerRightPiece: 20)! !

!PocketCubeWhenTwistLowerLayerRight methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:24'!
testRightSide

	self assert: pocketCube rightSide = (PocketCubeSide upperLeftPiece: 9 upperRightPiece: 10 lowerLeftPiece: 15 lowerRightPiece: 16)! !

!PocketCubeWhenTwistLowerLayerRight methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:22'!
testTopSide

	self assert: pocketCube topSide = (PocketCubeSide upperLeftPiece: 1 upperRightPiece: 2  lowerLeftPiece: 3 lowerRightPiece: 4)! !

PocketCubeTest subclass: #PocketCubeWhenTwistUpperLayerLeft
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Tests'!

!PocketCubeWhenTwistUpperLayerLeft methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:27'!
setUp

	super setUp.
	pocketCube twistUpperLayerLeft! !

!PocketCubeWhenTwistUpperLayerLeft methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:28'!
testBackSide

	self assert: pocketCube backSide = (PocketCubeSide upperLeftPiece: 5 upperRightPiece: 6 lowerLeftPiece: 19 lowerRightPiece: 20)! !

!PocketCubeWhenTwistUpperLayerLeft methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:28'!
testBottomSide

	self assert: pocketCube bottomSide = (PocketCubeSide upperLeftPiece: 21 upperRightPiece: 22 lowerLeftPiece: 23 lowerRightPiece: 24).! !

!PocketCubeWhenTwistUpperLayerLeft methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:27'!
testFrontSide

	self assert: pocketCube frontSide = (PocketCubeSide upperLeftPiece: 9 upperRightPiece: 10 lowerLeftPiece: 15 lowerRightPiece: 16)! !

!PocketCubeWhenTwistUpperLayerLeft methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:27'!
testLeftSide

	self assert: pocketCube leftSide = (PocketCubeSide upperLeftPiece: 7 upperRightPiece: 8  lowerLeftPiece: 13 lowerRightPiece: 14)! !

!PocketCubeWhenTwistUpperLayerLeft methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:28'!
testRightSide

	self assert: pocketCube rightSide = (PocketCubeSide upperLeftPiece: 11 upperRightPiece: 12 lowerLeftPiece: 17 lowerRightPiece: 18)! !

!PocketCubeWhenTwistUpperLayerLeft methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:29'!
testTopSide

	self assert: pocketCube topSide = (PocketCubeSide upperLeftPiece: 3 upperRightPiece: 1 lowerLeftPiece: 4 lowerRightPiece: 2)! !

PocketCubeTest subclass: #PocketCubeWhenTwistUpperLayerRight
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Tests'!

!PocketCubeWhenTwistUpperLayerRight methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:30'!
setUp

	super setUp.
	pocketCube twistUpperLayerRight! !

!PocketCubeWhenTwistUpperLayerRight methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:31'!
testBackSide

	self assert: pocketCube backSide = (PocketCubeSide upperLeftPiece: 9 upperRightPiece: 10 lowerLeftPiece: 19 lowerRightPiece: 20)! !

!PocketCubeWhenTwistUpperLayerRight methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:30'!
testBottomSide

	self assert: pocketCube bottomSide = (PocketCubeSide upperLeftPiece: 21 upperRightPiece: 22 lowerLeftPiece: 23 lowerRightPiece: 24).! !

!PocketCubeWhenTwistUpperLayerRight methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:31'!
testFrontSide

	self assert: pocketCube frontSide = (PocketCubeSide upperLeftPiece: 5 upperRightPiece: 6 lowerLeftPiece: 15 lowerRightPiece: 16)! !

!PocketCubeWhenTwistUpperLayerRight methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:31'!
testLeftSide

	self assert: pocketCube leftSide = (PocketCubeSide upperLeftPiece: 11 upperRightPiece: 12  lowerLeftPiece: 13 lowerRightPiece: 14)! !

!PocketCubeWhenTwistUpperLayerRight methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:31'!
testRightSide

	self assert: pocketCube rightSide = (PocketCubeSide upperLeftPiece: 7 upperRightPiece: 8 lowerLeftPiece: 17 lowerRightPiece: 18)! !

!PocketCubeWhenTwistUpperLayerRight methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:32'!
testTopSide

	self assert: pocketCube topSide = (PocketCubeSide upperLeftPiece: 2 upperRightPiece: 4 lowerLeftPiece: 1 lowerRightPiece: 3)! !

RectangleMorph subclass: #PocketCubeGameMorph
	instanceVariableNames: 'controller'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Morph'!

!PocketCubeGameMorph methodsFor: 'as yet unclassified' stamp: 'hjo 7/31/2010 19:42'!
controller

	^controller! !

!PocketCubeGameMorph methodsFor: 'as yet unclassified' stamp: 'hjo 7/31/2010 19:42'!
controller: aPocketCubeController 

	controller := aPocketCubeController 
! !

!PocketCubeGameMorph methodsFor: 'as yet unclassified' stamp: 'hjo 7/31/2010 19:23'!
handlesKeyboard: evt

	^true! !

!PocketCubeGameMorph methodsFor: 'as yet unclassified' stamp: 'hjo 1/31/2011 18:59'!
initialize 

	super initialize.
	self openInWorld.
	self bounds: (0@0 corner: 640@480).
	self extent:  454@351.
	self position: 0@0.
! !

!PocketCubeGameMorph methodsFor: 'as yet unclassified' stamp: 'hjo 7/31/2010 19:49'!
keyStroke: anEvent

	anEvent keyValue = 97 ifTrue: [^self controller rotateLeft].
	anEvent keyValue = 115 ifTrue: [^self controller rotateRight].
	anEvent keyValue = 122 ifTrue: [^self controller rotateClockwise].
	anEvent keyValue = 120 ifTrue: [^self controller rotateCounterClockwise].	
	anEvent keyValue = 106 ifTrue: [^self controller twistUpperLayerLeft].	
	anEvent keyValue = 107 ifTrue: [^self controller twistUpperLayerRight].
	anEvent keyValue = 110 ifTrue: [^self controller twistLowerLayerLeft].
	anEvent keyValue = 109 ifTrue: [^self controller twistLowerLayerRight].
	Transcript show: anEvent keyValue; cr! !

Object subclass: #PocketCube
	instanceVariableNames: 'topSide leftSide bottomSide rightSide frontSide backSide'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube'!

!PocketCube methodsFor: 'as yet unclassified' stamp: 'hjo 1/31/2011 19:16'!
allSides

	^Array streamContents: [:stream| 
		stream nextPut: topSide.
		stream nextPut: leftSide.
		stream nextPut: bottomSide.
		stream nextPut: rightSide.
		stream nextPut: frontSide.
		stream nextPut: backSide  ]! !

!PocketCube methodsFor: 'testing' stamp: 'hjo 1/31/2011 19:14'!
allSidesAreOneColor

	^self allSides allSatisfy: [:each| each isOneColor ] ! !

!PocketCube methodsFor: 'rotate' stamp: 'hjo 7/18/2010 22:53'!
arrayOfBackSide

	^Array with: backSide! !

!PocketCube methodsFor: 'sides' stamp: 'hjo 7/17/2010 20:31'!
backSide

	^backSide! !

!PocketCube methodsFor: 'sides' stamp: 'hjo 7/17/2010 20:32'!
backSide: aPocketCubeSide 

	backSide := aPocketCubeSide ! !

!PocketCube methodsFor: 'sides' stamp: 'hjo 7/17/2010 20:23'!
bottomSide

	^bottomSide! !

!PocketCube methodsFor: 'sides' stamp: 'hjo 7/17/2010 20:22'!
bottomSide: aPocketCubeSide 

	bottomSide := aPocketCubeSide ! !

!PocketCube methodsFor: 'sides' stamp: 'hjo 7/17/2010 20:29'!
frontSide

	^frontSide! !

!PocketCube methodsFor: 'sides' stamp: 'hjo 7/17/2010 20:30'!
frontSide: aPocketCubeSide 

	frontSide := aPocketCubeSide ! !

!PocketCube methodsFor: 'sides' stamp: 'hjo 7/17/2010 20:19'!
leftSide

	^leftSide! !

!PocketCube methodsFor: 'sides' stamp: 'hjo 7/17/2010 20:19'!
leftSide: aPocketCubeSide 

	leftSide := aPocketCubeSide! !

!PocketCube methodsFor: 'sides' stamp: 'hjo 7/17/2010 20:26'!
rightSide

	^rightSide! !

!PocketCube methodsFor: 'sides' stamp: 'hjo 7/17/2010 20:27'!
rightSide: aPocketCubeSide 

	rightSide := aPocketCubeSide! !

!PocketCube methodsFor: 'rotate' stamp: 'hjo 2/1/2011 18:49'!
rotateClockwise

	self rotateClockwiseForSideAroundFrontFace.
	self rotateSidesClockwise: self sidesWithoutBackSide 
		rotateSidesCounterClockwise: self arrayOfBackSide.
	self triggerEvent: #pocketCubeChanged.! !

!PocketCube methodsFor: 'rotate' stamp: 'hjo 7/18/2010 22:43'!
rotateClockwiseForSideAroundFrontFace

	self setSidesTopRightBottomLeft: 
		(Array 
			with: leftSide 
			with: topSide 
			with: rightSide 
			with: bottomSide)
! !

!PocketCube methodsFor: 'rotate' stamp: 'hjo 2/1/2011 18:49'!
rotateCounterClockwise

	self rotateCounterClockwiseForSideAroundFrontFace.
	self rotateSidesClockwise: self arrayOfBackSide 
		rotateSidesCounterClockwise: self sidesWithoutBackSide.
	self triggerEvent: #pocketCubeChanged.! !

!PocketCube methodsFor: 'rotate' stamp: 'hjo 7/18/2010 22:44'!
rotateCounterClockwiseForSideAroundFrontFace

	self setSidesTopRightBottomLeft:
		(Array
			with: rightSide
			with: bottomSide
			with: leftSide
			with: topSide)! !

!PocketCube methodsFor: 'rotate' stamp: 'hjo 7/26/2010 02:00'!
rotateLeft

	self twistUpperLayerRight.
	self twistLowerLayerRight! !

!PocketCube methodsFor: 'rotate' stamp: 'hjo 7/18/2010 07:49'!
rotateLeftForSides

	| tempSide |
	tempSide := backSide.
	backSide := rightSide.
	rightSide := frontSide.
	frontSide := leftSide.
	leftSide := tempSide! !

!PocketCube methodsFor: 'rotate' stamp: 'hjo 7/26/2010 02:02'!
rotateRight

	self twistUpperLayerLeft.
	self twistLowerLayerLeft! !

!PocketCube methodsFor: 'rotate' stamp: 'hjo 7/18/2010 09:44'!
rotateRightForSides

	| tempSide |
	tempSide := leftSide.
	leftSide := frontSide.
	frontSide := rightSide.
	rightSide := backSide.
	backSide := tempSide! !

!PocketCube methodsFor: 'rotate' stamp: 'hjo 7/18/2010 22:50'!
rotateSidesClockwise: anArray rotateSidesCounterClockwise: anArray2 

	anArray do: [:each| each rotateClockwise ].
	anArray2 do: [:each| each rotateCounterClockwise ].! !

!PocketCube methodsFor: 'rotate' stamp: 'hjo 7/18/2010 22:41'!
setSidesTopRightBottomLeft: anArray

	topSide := anArray at: 1.
	rightSide := anArray at: 2.
	bottomSide := anArray at: 3.
	leftSide := anArray at: 4! !

!PocketCube methodsFor: 'as yet unclassified' stamp: 'hjo 2/1/2011 18:17'!
sidesAreUpperLayerTwistedLeft

	(self sidesInOrder at:2) copyOutLowerLayer = (self sidesInOrder at:1) copyOutUpperLayer
		ifFalse: [^false].
	(self sidesInOrder at:3) copyOutLowerLayer = (self sidesInOrder at:2) copyOutUpperLayer
		ifFalse: [^false].	
	(self sidesInOrder at:4) copyOutLowerLayer = (self sidesInOrder at:3) copyOutUpperLayer
		ifFalse: [^false].
	(self sidesInOrder at:1) copyOutLowerLayer = (self sidesInOrder at:4) copyOutUpperLayer
		ifFalse: [^false].	
	^true! !

!PocketCube methodsFor: 'as yet unclassified' stamp: 'hjo 2/1/2011 12:18'!
sidesAreUpperLayerTwistedRight

	(self sidesInOrder at:1) copyOutLowerLayer = (self sidesInOrder at:2) copyOutUpperLayer
		ifFalse: [^false].
	(self sidesInOrder at:2) copyOutLowerLayer = (self sidesInOrder at:3) copyOutUpperLayer
		ifFalse: [^false].	
	(self sidesInOrder at:3) copyOutLowerLayer = (self sidesInOrder at:4) copyOutUpperLayer
		ifFalse: [^false].
	(self sidesInOrder at:4) copyOutLowerLayer = (self sidesInOrder at:1) copyOutUpperLayer
		ifFalse: [^false].	
	^true
"(1 to:3)doCouple: [:a :b| ]."! !

!PocketCube methodsFor: 'as yet unclassified' stamp: 'hjo 2/1/2011 18:27'!
sidesAreUpperLayerTwistedTwice

	(self sidesInOrder at:1) copyOutLowerLayer = (self sidesInOrder at:3) copyOutUpperLayer
		ifFalse: [^false].
	(self sidesInOrder at:2) copyOutLowerLayer = (self sidesInOrder at:4) copyOutUpperLayer
		ifFalse: [^false].	
	(self sidesInOrder at:3) copyOutLowerLayer = (self sidesInOrder at:1) copyOutUpperLayer
		ifFalse: [^false].
	(self sidesInOrder at:4) copyOutLowerLayer = (self sidesInOrder at:2) copyOutUpperLayer
		ifFalse: [^false].	
	^true
"(1 to:3)doCouple: [:a :b| ]."! !

!PocketCube methodsFor: 'twist' stamp: 'hjo 7/17/2010 22:38'!
sidesInOrder

	^Array with: leftSide with: frontSide with: rightSide with:backSide! !

!PocketCube methodsFor: 'twist' stamp: 'hjo 7/17/2010 22:36'!
sidesReverseOrder

	^Array with: backSide with: rightSide with: frontSide with:leftSide! !

!PocketCube methodsFor: 'rotate' stamp: 'hjo 7/18/2010 22:55'!
sidesWithoutBackSide
	
	^Array with: frontSide with: topSide with: leftSide with: rightSide with: bottomSide! !

!PocketCube methodsFor: 'as yet unclassified' stamp: 'hjo 2/1/2011 18:46'!
slidesAreVerticallyLayerTwisted

	self rotateClockwise.
	[self sidesAreUpperLayerTwistedLeft ifTrue: [^true].
	self sidesAreUpperLayerTwistedRight ifTrue: [^true].
	self sidesAreUpperLayerTwistedTwice ifTrue: [^true].
	^false] ensure: [self rotateCounterClockwise].
	! !

!PocketCube methodsFor: 'sides' stamp: 'hjo 7/17/2010 20:15'!
topSide

	^topSide! !

!PocketCube methodsFor: 'sides' stamp: 'hjo 7/17/2010 20:15'!
topSide: aPocketCubeSide 

	topSide := aPocketCubeSide! !

!PocketCube methodsFor: 'twist' stamp: 'hjo 2/1/2011 18:47'!
twistLowerLayerLeft

	bottomSide rotateCounterClockwise.
	self twistLowerLayerWithSides: self sidesInOrder.
	self triggerEvent: #pocketCubeChanged.! !

!PocketCube methodsFor: 'twist' stamp: 'hjo 2/1/2011 12:57'!
twistLowerLayerRight

	bottomSide rotateClockwise.
	self twistLowerLayerWithSides: self sidesReverseOrder.
	self triggerEvent: #pocketCubeChanged! !

!PocketCube methodsFor: 'twist' stamp: 'hjo 7/17/2010 22:32'!
twistLowerLayerWithSides: anArray 

	| twoPieces |
	twoPieces := (anArray at:1) copyOutLowerLayer.
	(anArray at:1) copyInLowerLayer: (anArray at:2) copyOutLowerLayer.
	(anArray at:2) copyInLowerLayer: (anArray at:3) copyOutLowerLayer.
	(anArray at:3) copyInLowerLayer: (anArray at:4) copyOutLowerLayer.
	(anArray at:4) copyInLowerLayer: twoPieces! !

!PocketCube methodsFor: 'twist' stamp: 'hjo 2/1/2011 18:48'!
twistUpperLayerLeft

	topSide rotateClockwise.
	self twistUpperLayerWithSides: self sidesInOrder.
	self triggerEvent: #pocketCubeChanged.! !

!PocketCube methodsFor: 'twist' stamp: 'hjo 2/1/2011 18:48'!
twistUpperLayerRight

	topSide rotateCounterClockwise.
	self twistUpperLayerWithSides: self sidesReverseOrder.
	self triggerEvent: #pocketCubeChanged.! !

!PocketCube methodsFor: 'twist' stamp: 'hjo 7/17/2010 22:31'!
twistUpperLayerWithSides: anArray 

	| twoPieces |
	twoPieces := (anArray at:1) copyOutUpperLayer.
	(anArray at:1) copyInUpperLayer: (anArray at:2) copyOutUpperLayer.
	(anArray at:2) copyInUpperLayer: (anArray at:3) copyOutUpperLayer.
	(anArray at:3) copyInUpperLayer: (anArray at:4) copyOutUpperLayer.
	(anArray at:4) copyInUpperLayer: twoPieces! !

Object subclass: #PocketCubeController
	instanceVariableNames: 'rectangleMorph model frontSideController topSideController bottomSideController leftSideController rightSideController backSideController'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Morph'!

!PocketCubeController methodsFor: 'as yet unclassified' stamp: 'hjo 7/26/2010 10:55'!
beScrambled: aSmallInteger 

	| gripOperations twistOperations |
	aSmallInteger timesRepeat: 
	[
		gripOperations :=  #(
			(rotateClockwise) 
			(rotateCounterClockwise) 
			(rotateClockwise) 
			(rotateCounterClockwise) 
			(rotateLeft rotateClockwise)
			(rotateRight rotateClockwise)
			(rotateLeft rotateCounterClockwise)
			(rotateRight rotateCounterClockwise)).
			
		twistOperations := #(
			(twistLowerLayerLeft)
			(twistLowerLayerRight)
			(twistLowerLayerRight twistLowerLayerRight)
			(twistUpperLayerLeft) 
			(twistUpperLayerRight)
			(twistUpperLayerRight twistUpperLayerRight)
		). 
		
		gripOperations atRandom do: [:selector| self perform: selector].
		twistOperations atRandom do: [:selector| self perform: selector].
	]! !

!PocketCubeController methodsFor: 'as yet unclassified' stamp: 'hjo 7/26/2010 00:27'!
deleteMorph

	rectangleMorph delete! !

!PocketCubeController methodsFor: 'as yet unclassified' stamp: 'hjo 8/9/2010 22:57'!
focused

	ActiveHand keyboardFocus: rectangleMorph! !

!PocketCubeController methodsFor: 'as yet unclassified' stamp: 'hjo 1/31/2011 18:57'!
initialize

	super initialize.
	self initializeModel.
	rectangleMorph := PocketCubeGameMorph roundRectPrototype.
	rectangleMorph controller: self.
		
	frontSideController := PocketCubeSideController openMorphOn: model sideAccessor: #frontSide atOrigin: 140@145 rectangleMorph: rectangleMorph.
	topSideController := PocketCubeSideController openMorphOn: model sideAccessor: #topSide atOrigin: 140@55 rectangleMorph: rectangleMorph.
	bottomSideController := PocketCubeSideController openMorphOn: model sideAccessor: #bottomSide atOrigin: 140@235 rectangleMorph: rectangleMorph.
	leftSideController := PocketCubeSideController openMorphOn: model sideAccessor: #leftSide atOrigin: 50@145 rectangleMorph: rectangleMorph.
	rightSideController := PocketCubeSideController openMorphOn: model sideAccessor: #rightSide atOrigin: 230@145 rectangleMorph: rectangleMorph.
	backSideController := PocketCubeSideController openMorphOn: model sideAccessor: #backSide atOrigin: 320@145 rectangleMorph: rectangleMorph.
! !

!PocketCubeController methodsFor: 'as yet unclassified' stamp: 'hjo 2/1/2011 12:55'!
initializeModel

	model := PocketCube new.
	model when: #pocketCubeChanged send: #refreshMorph to: self. 
	
	model topSide: (PocketCubeSide ofAllSamePieces: Color red).
	model leftSide: (PocketCubeSide ofAllSamePieces: Color white).
	model bottomSide: (PocketCubeSide ofAllSamePieces: Color orange).
	model rightSide: (PocketCubeSide ofAllSamePieces: Color yellow).
	model frontSide: (PocketCubeSide ofAllSamePieces: Color green).
	model backSide: (PocketCubeSide ofAllSamePieces: Color blue).! !

!PocketCubeController methodsFor: 'as yet unclassified' stamp: 'hjo 9/15/2010 02:03'!
position: aPoint 

	rectangleMorph position: aPoint! !

!PocketCubeController methodsFor: 'as yet unclassified' stamp: 'hjo 7/26/2010 01:46'!
refreshMorph

	frontSideController refreshMorph.
	backSideController refreshMorph.
	leftSideController refreshMorph.
	rightSideController refreshMorph.
	topSideController refreshMorph.
	bottomSideController refreshMorph.! !

!PocketCubeController methodsFor: 'rotate' stamp: 'hjo 2/1/2011 21:44'!
rotateClockwise
	
	model rotateClockwise.! !

!PocketCubeController methodsFor: 'rotate' stamp: 'hjo 2/1/2011 21:45'!
rotateCounterClockwise

	model rotateCounterClockwise.! !

!PocketCubeController methodsFor: 'rotate' stamp: 'hjo 2/1/2011 21:45'!
rotateLeft
	model rotateLeft.! !

!PocketCubeController methodsFor: 'rotate' stamp: 'hjo 2/1/2011 21:46'!
rotateRight

	model rotateRight.! !

!PocketCubeController methodsFor: 'as yet unclassified' stamp: 'hjo 7/31/2010 19:42'!
setControllerForGameMorph
	
	rectangleMorph controller: self! !

!PocketCubeController methodsFor: 'as yet unclassified' stamp: 'hjo 1/31/2011 19:04'!
solve

	| recog |
	recog := PocketCubeRecognizer on: model.
	^recog! !

!PocketCubeController methodsFor: 'twist' stamp: 'hjo 2/1/2011 21:46'!
twistLowerLayerLeft

	model twistLowerLayerLeft.! !

!PocketCubeController methodsFor: 'twist' stamp: 'hjo 2/1/2011 21:47'!
twistLowerLayerRight

	model twistLowerLayerRight.! !

!PocketCubeController methodsFor: 'twist' stamp: 'hjo 2/1/2011 21:47'!
twistUpperLayerLeft

	model twistUpperLayerLeft.! !

!PocketCubeController methodsFor: 'twist' stamp: 'hjo 2/1/2011 21:47'!
twistUpperLayerRight

	model twistUpperLayerRight.! !

Object subclass: #PocketCubePattern
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Recognizer'!

PocketCubePattern subclass: #PocketCubeSolvedPattern
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Recognizer'!

!PocketCubeSolvedPattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/1/2011 12:56'!
oneStepBetterFor: aPocketCube 

	"do nothing"! !

PocketCubePattern subclass: #PocketCubeUnknownPattern
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Recognizer'!

!PocketCubeUnknownPattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/1/2011 18:23'!
oneStepBetterFor: aPocketCube 

	self error: 'i do not know what to do. 
	please, 
		check #scanPattern.
		define new pattern class.'.! !

PocketCubePattern subclass: #PocketCubeUpperLayerTwistedLeftPattern
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Recognizer'!

!PocketCubeUpperLayerTwistedLeftPattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/1/2011 18:18'!
oneStepBetterFor: aPocketCube 

	aPocketCube twistUpperLayerRight! !

PocketCubePattern subclass: #PocketCubeUpperLayerTwistedRightPattern
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Recognizer'!

!PocketCubeUpperLayerTwistedRightPattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/1/2011 18:12'!
oneStepBetterFor: aPocketCube 

	aPocketCube twistUpperLayerLeft! !

PocketCubePattern subclass: #PocketCubeUpperLayerTwistedTwicePattern
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Recognizer'!

!PocketCubeUpperLayerTwistedTwicePattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/1/2011 18:28'!
oneStepBetterFor: aPocketCube 

	2 timesRepeat: [aPocketCube twistUpperLayerRight]! !

PocketCubePattern subclass: #PocketCubeVerticallyLayerTwistedPattern
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Recognizer'!

!PocketCubeVerticallyLayerTwistedPattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/1/2011 18:56'!
oneStepBetterFor: aPocketCube 

	aPocketCube rotateCounterClockwise.! !

Object subclass: #PocketCubeRecognizer
	instanceVariableNames: 'pocketCube pattern'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Recognizer'!

!PocketCubeRecognizer classSide methodsFor: 'as yet unclassified' stamp: 'hjo 1/31/2011 19:05'!
on: aPocketCube 

	|instance|
	instance := self new.
	instance pocketCube: aPocketCube.
	^instance.! !

!PocketCubeRecognizer methodsFor: 'as yet unclassified' stamp: 'hjo 2/1/2011 12:54'!
oneStepBetter

	self scanPattern.
	self oneStepBetterWithPattern.
	pocketCube triggerEvent: #pocketCubeChanged! !

!PocketCubeRecognizer methodsFor: 'as yet unclassified' stamp: 'hjo 2/1/2011 12:57'!
oneStepBetterWithPattern

	pattern oneStepBetterFor: pocketCube.! !

!PocketCubeRecognizer methodsFor: 'accessing' stamp: 'hjo 2/1/2011 12:53'!
pocketCube: aPocketCube 

	pocketCube := aPocketCube.! !

!PocketCubeRecognizer methodsFor: 'as yet unclassified' stamp: 'hjo 2/1/2011 18:42'!
scanPattern

	pocketCube allSidesAreOneColor ifTrue: [^pattern := PocketCubeSolvedPattern].
	pocketCube sidesAreUpperLayerTwistedLeft ifTrue: [^pattern := PocketCubeUpperLayerTwistedLeftPattern ].
	pocketCube sidesAreUpperLayerTwistedRight ifTrue: [^pattern := PocketCubeUpperLayerTwistedRightPattern ].
	pocketCube sidesAreUpperLayerTwistedTwice ifTrue: [^pattern := PocketCubeUpperLayerTwistedTwicePattern ].
	pocketCube slidesAreVerticallyLayerTwisted ifTrue: [^pattern := PocketCubeVerticallyLayerTwistedPattern. ].
	^pattern := PocketCubeUnknownPattern! !

Object subclass: #PocketCubeScrambler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube'!

!PocketCubeScrambler methodsFor: 'as yet unclassified' stamp: 'hjo 7/6/2010 09:01'!
printOnTranscriptScrambleSequenceOf: anInteger

	Transcript show: (self scrambleSequenceOf: anInteger); cr; flush! !

!PocketCubeScrambler methodsFor: 'as yet unclassified' stamp: 'hjo 7/6/2010 09:04'!
scrambleSequenceOf: anInteger

	| d a s n |
	d := #(x y z).
	a := #(-1 1 2).

	s := OrderedCollection new.

	anInteger timesRepeat: [
	s isEmpty
		ifTrue: [s add: (Array with: d atRandom with: a atRandom)]
		ifFalse: [
			[n := (Array with: d atRandom with: a atRandom). s last first = n first ] whileTrue.
			s add: n.
			]
	].
	^s asArray! !

Object subclass: #PocketCubeSide
	instanceVariableNames: 'upperLeftPiece upperRightPiece lowerRightPiece lowerLeftPiece'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube'!

!PocketCubeSide classSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/26/2010 00:47'!
ofAllSamePieces: aColor 

	^self upperLeftPiece: aColor upperRightPiece: aColor lowerLeftPiece: aColor lowerRightPiece: aColor ! !

!PocketCubeSide classSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/17/2010 19:45'!
upperLeftPiece: aSmallInteger upperRightPiece: aSmallInteger2 lowerLeftPiece: aSmallInteger3 lowerRightPiece: aSmallInteger4 

	| instance |
	instance := self new.
	instance upperLeftPiece: aSmallInteger.
	instance upperRightPiece: aSmallInteger2.
	instance lowerLeftPiece: aSmallInteger3.
	instance lowerRightPiece: aSmallInteger4.
	^instance! !

!PocketCubeSide methodsFor: 'comparing' stamp: 'hjo 7/18/2010 01:29'!
= other

	^self equalityComparison of: self and: other! !

!PocketCubeSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/17/2010 20:03'!
copyInLowerLayer: anArray 

	lowerLeftPiece := anArray first.
	lowerRightPiece := anArray second! !

!PocketCubeSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/17/2010 19:58'!
copyInUpperLayer: anArray 

	upperLeftPiece := anArray first.
	upperRightPiece := anArray second! !

!PocketCubeSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/17/2010 19:55'!
copyOutLowerLayer

	^Array with: lowerLeftPiece with: lowerRightPiece! !

!PocketCubeSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/17/2010 19:53'!
copyOutUpperLayer

	^Array with: upperLeftPiece with: upperRightPiece! !

!PocketCubeSide methodsFor: 'comparing' stamp: 'hjo 7/18/2010 01:28'!
equalityComparison

	^EqualityComparison new selectors: #(upperLeftPiece upperRightPiece lowerLeftPiece lowerRightPiece)! !

!PocketCubeSide methodsFor: 'comparing' stamp: 'hjo 7/18/2010 01:33'!
hash

	^self equalityComparison hashOf: self! !

!PocketCubeSide methodsFor: 'testing' stamp: 'hjo 1/31/2011 19:13'!
isOneColor

	^(Set with: upperLeftPiece with: upperRightPiece with: lowerLeftPiece with: lowerRightPiece) size = 1! !

!PocketCubeSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/17/2010 19:44'!
lowerLeftPiece

	^lowerLeftPiece! !

!PocketCubeSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/17/2010 19:44'!
lowerLeftPiece: aSmallInteger 
	lowerLeftPiece := aSmallInteger ! !

!PocketCubeSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/17/2010 19:32'!
lowerRightPiece

	^lowerRightPiece! !

!PocketCubeSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/17/2010 19:30'!
lowerRightPiece: aSmallInteger 

	lowerRightPiece := aSmallInteger ! !

!PocketCubeSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:56'!
printPieces

	^String streamContents: [:stream|
		stream print: upperLeftPiece.
		stream space.
		stream print: upperRightPiece.
		stream cr.
		stream print: lowerLeftPiece.
		stream space.
		stream print: lowerRightPiece]! !

!PocketCubeSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/17/2010 19:43'!
rotateClockwise

	|temp|
	temp := lowerLeftPiece.
	lowerLeftPiece := lowerRightPiece.
	lowerRightPiece := upperRightPiece.
	upperRightPiece := upperLeftPiece.
	upperLeftPiece := temp.
	! !

!PocketCubeSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/17/2010 19:48'!
rotateCounterClockwise

	| temp |
	temp := upperLeftPiece.
	upperLeftPiece := upperRightPiece.
	upperRightPiece := lowerRightPiece.
	lowerRightPiece := lowerLeftPiece.
	lowerLeftPiece := temp! !

!PocketCubeSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/17/2010 19:31'!
upperLeftPiece

	^upperLeftPiece! !

!PocketCubeSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/17/2010 19:29'!
upperLeftPiece: aSmallInteger 

	upperLeftPiece := aSmallInteger ! !

!PocketCubeSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/17/2010 19:31'!
upperRightPiece

	^upperRightPiece! !

!PocketCubeSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/17/2010 19:29'!
upperRightPiece: aSmallInteger 

	upperRightPiece := aSmallInteger ! !

Object subclass: #PocketCubeSideController
	instanceVariableNames: 'pocketCube sideAccessor upperLeftPieceMorph upperRightPieceMorph lowerRightPieceMorph lowerLeftPieceMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Morph'!

!PocketCubeSideController classSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/26/2010 02:11'!
openMorphOn: aPocketCube sideAccessor: aByteSymbol atOrigin: aPoint rectangleMorph: aRectangleMorph 

	| instance |
	instance := self new.
	instance pocketCube: aPocketCube.
	instance sideAccessor: aByteSymbol.
	instance openMorphAtOrigin: aPoint rectangleMorph: aRectangleMorph.
	^instance! !

!PocketCubeSideController methodsFor: 'as yet unclassified' stamp: 'hjo 7/26/2010 01:35'!
openBorderedRectangleMorph

	| morph | 
	morph := RectangleMorph new.
	morph borderWidth: 2.
	morph extent: 40@40.
	^morph! !

!PocketCubeSideController methodsFor: 'as yet unclassified' stamp: 'hjo 7/26/2010 02:08'!
openMorphAtOrigin: aPoint rectangleMorph: aRectangleMorph 
	
	| block rectMorph |
	block := [:offset :accessed | 
		rectMorph := self openBorderedRectangleMorph.
		aRectangleMorph addMorph: rectMorph.
		rectMorph position: aRectangleMorph position + offset + aPoint.
		rectMorph color: accessed.
		rectMorph ].
	
	upperLeftPieceMorph := block value: 0@0 value: self pocketCubeSide upperLeftPiece.
	upperRightPieceMorph := block value: 42@0 value: self pocketCubeSide upperRightPiece.
	lowerRightPieceMorph := block value: 42@42 value: self pocketCubeSide lowerRightPiece.
	lowerLeftPieceMorph := block value: 0@42 value: self pocketCubeSide lowerLeftPiece.! !

!PocketCubeSideController methodsFor: 'as yet unclassified' stamp: 'hjo 7/26/2010 02:11'!
pocketCube: aPocketCube 

	pocketCube := aPocketCube! !

!PocketCubeSideController methodsFor: 'as yet unclassified' stamp: 'hjo 7/26/2010 02:08'!
pocketCubeSide

	^pocketCube perform: sideAccessor! !

!PocketCubeSideController methodsFor: 'as yet unclassified' stamp: 'hjo 7/26/2010 02:08'!
refreshMorph

	upperLeftPieceMorph color: self pocketCubeSide upperLeftPiece.
	upperRightPieceMorph color: self pocketCubeSide upperRightPiece.
	lowerLeftPieceMorph color: self pocketCubeSide lowerLeftPiece.
	lowerRightPieceMorph color: self pocketCubeSide lowerRightPiece! !

!PocketCubeSideController methodsFor: 'as yet unclassified' stamp: 'hjo 7/26/2010 02:11'!
sideAccessor: aByteSymbol 

	sideAccessor := aByteSymbol! !
